begin def

' Including args.h
   sub getargs
   sub quoted( quoter$ )
   sub param
   sub other
   sub store( item$ )

   dim argv$[ 100 ]

   common cmd$, argc%

begin code
    fprint( 2, "TIMER v1.1MR (c) Copyright Bruce M. Axtens, 1996.\n" )

    call getargs

    if argc% < 2 then
        print "Timer <prog> <parameters>\n"
        end
    endif

    prog$ = argv$[ 1 ]
    parm$ = ""
    lim% = argc% - 1
    for i% = 2 to lim%
        parm$ = parm$ + argv$[ i% ] + " "
    next

    tt& = timertick
    j% = exec( prog$, parm$ )
    res& = timertick
    res& = res& - tt&
    print "Program took " + res& + " ticks to run.\n"
    end

' Including args.sub
sub getargs
   dquote$ = chr(34)
   squote$ = "'"

   me$ = mypath()
   me$ = ftruename( me$ )
   argv$[ 0 ] = me$

   argc% = 1

   'get command line
   cmd$ = cmdline

   'repeat until empty command line
   forever% = true
   while forever%
      cmd$ = ltrim( cmd$ )
      if cmd$ = "" then
         exit while
      endif

      'get first char of command line
      first$ = left( cmd$, 1 )

      select case first$
         case squote$
            call quoted( squote$ )
         case dquote$
            call quoted( dquote$ )
         case "/"
            call param
         case "-"
            call param
         case else
            call other
      end select
   wend
end sub
sub quoted( quoter$ )
   item$ = mid( cmd$, 2 )
   there% = sinstr( item$, quoter$ )
   if there% > 0 then
      there% = there% - 1
      item$ = left( item$, there% ) 'mid( item$, 1, there% )
      there% = there% + 3
      '... and remove this first item from the command line
      cmd$ = mid( cmd$, there% )
   else
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub param
   sep% = 32
   there% = cinstr( cmd$, sep% )
   if there% > 0 then
      there% = there% - 1
      item$ = left( cmd$, there% )
      '... and remove this first item from the command line
      there% = there% + 2
      cmd$ = mid( cmd$, there% )
   else
      item$ = cmd$
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub other
   'otherwise next item in array is first item
   there% = cinstr( cmd$, 32 )
   if there% > 0 then
      there% = there% - 1
      item$ = left( cmd$, there% )
      '... and remove this first item from the command line
      there% = there% + 2
      cmd$ = mid( cmd$, there% )
   else
      item$ = cmd$
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub store( item$ )
   argv$[ argc% ] = item$
   argc% = argc% + 1
end sub
